/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameactual;

/**
 *
 * @author Griff
 */
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import gamelibrary.gameobject.Movable;
import gamelibrary.collisiondetection.Collidable;
import gamelibrary.gameobject.GameObject;
import gamelibrary.collisiondetection.Property;
import java.util.Vector;

public class Foe extends Collidable implements Movable{

    private Image spriteImg;
    private int speed;
    private Coordinates coordinates;
    private GameObject victim;
    private int lastX = 0;
    private int lastY = 0;

    public Foe(Coordinates coordinates, int speed, GameObject Victim){
        this.speed = speed;
        this.coordinates = coordinates;
        this.victim = Victim;
        lethal = true;
        impassable = false;
        try
        {
            int[] seq = {0, 0, 0, 0, 1, 1, 1, 1};  //Frame sequence
            spriteImg = Image.createImage("/foe.png");
            sprite = new MySprite(spriteImg, 1, 2);
            sprite.setFrameSequence(seq);
            sprite.defineReferencePixel(sprite.getWidth()/2, sprite.getHeight()/2);
            sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        }
        catch(Exception e)
        {
            System.out.println("Error loading sprite!!");
        }
    }

    public void chase(){
        int howFarX = 0;
        int howFarY = 0;
        int distanceX = victim.getCoordinates().getX() - coordinates.getX();
        int distanceY = victim.getCoordinates().getY() - coordinates.getY();
        if (distanceX > distanceY){
            if(distanceX > 0){
                howFarX += speed;
            }
            else if(distanceX < 0){
                howFarX -= speed;
            }
        }
        else{
            if(distanceY > 0){
                howFarY += speed;
            }
            else if(distanceY < 0){
                howFarY -= speed;
            }
        }
        move(howFarX, howFarY);
    }

    public void move(int howFarX, int howFarY){
        coordinates.addX(howFarX);
        coordinates.addY(howFarY);
        sprite.nextFrame();
        sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        lastX = howFarX;
        lastY = howFarY;
    }

    public void action(Collidable object,  boolean olethal, boolean okillable, boolean oimpassable){
        for (int i = 0; i < properties.size(); i++){
            if (((Property) properties.elementAt(i)) == Property.IMPASSABLE){
                int howFarX = -lastX;
            int howFarY = -lastY;
            int distanceX = victim.getCoordinates().getX() - coordinates.getX();
            int distanceY = victim.getCoordinates().getY() - coordinates.getY();
            //if last move was left
            if ((lastX < 0)){
                if (distanceY < 0){
                    howFarY += speed;
                }
                else{
                    howFarY -= speed;
                }
            }
             //if last move was right
            else if (lastX > 0){
                if (distanceY > 0){
                    howFarY += speed;
                }
                else{
                    howFarY -= speed;
                }
            }
             //if last move was up
            else if ((lastY < 0)){
                if (distanceX > 0){
                    howFarX += speed;
                }
                else{
                    howFarX -= speed;
                }
            }
             //if last move was down
            else if ((lastY > 0)){
                if (distanceX > 0){
                    howFarX += speed;
                }
                else{
                    howFarX -= speed;
                }
            }
            move(howFarX, howFarY);
            }
        }
    }

    public Coordinates getCoordinates(){
        return coordinates;
    }

    public void setVictim(GameObject victim){
        this.victim = victim;
    }

    public void addToLayerManager(LayerManager layerManager){
        layerManager.append(sprite);
    }

    public boolean die(){
        return false;
    }
}
