/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameactual;

/**
 *
 * @author Griff
 */
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import gamelibrary.collisiondetection.Collidable;
import gamelibrary.collisiondetection.Property;
import gamelibrary.gameobject.*;
import java.util.Vector;

public class Player extends Collidable implements Movable, InputListener{

    private Image spriteImg;
    private boolean living;
    private boolean isMirrored;
    private int speed;
    private Coordinates coordinates;
    private int lastX = 0;
    private int lastY = 0;

    public Player(Coordinates coordinates){
        super();
        this.coordinates = coordinates;
        lethal = false;
        isMirrored = false;
        living = true;
        impassable = false;
        speed = 2;
        try
        {
            int[] seq = {0, 0, 1, 1};  //Frame sequence
            spriteImg = Image.createImage("/pacman.png");
            spriteImg.getWidth();
            spriteImg.getHeight();
            sprite = new MySprite(spriteImg, 1, 2);
            sprite.setFrameSequence(seq);
            sprite.defineReferencePixel(sprite.getWidth()/2, sprite.getHeight()/2);
            sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        }
        catch(Exception e)
        {
            System.out.println("Error loading sprite!!");
        }
    }

    public void acceptInput(int keyMask){
        if (living){
            int howFarX = 0;
            int howFarY = 0;
            if((keyMask & LEFT_PRESSED)!=0){
                if (!isMirrored){
                    sprite.setTransform(Sprite.TRANS_MIRROR);
                    isMirrored = true;
                }
                howFarX -= speed;
            }
            else if((keyMask & RIGHT_PRESSED)!=0){
                if (isMirrored){
                    sprite.setTransform(Sprite.TRANS_NONE);
                    isMirrored = false;
                }
                howFarX += speed;
            }
            else if((keyMask & UP_PRESSED)!=0){
                howFarY -= speed;
            }
            else if((keyMask & DOWN_PRESSED)!=0){
                howFarY += speed;
            }
            move(howFarX, howFarY);
        }
    }

    public void move(int howFarX, int howFarY){
        coordinates.addX(howFarX);
        coordinates.addY(howFarY);
        sprite.nextFrame();
        sprite.setRefPixelPosition(coordinates.getX(), coordinates.getY());
        lastX = howFarX;
        lastY = howFarY;
    }

    public void action(Collidable object,  Vector properties){
        for (int i = 0; i < properties.size(); i++){
            if (((Property) properties.elementAt(i)) == Property.LETHAL){
                living = false;
            }
            if (((Property) properties.elementAt(i)) == Property.IMPASSABLE){
                move(-lastX, -lastY);
            }
        }
    }

    public Coordinates getCoordinates(){
        return coordinates;
    }

    public void addToLayerManager(LayerManager layerManager){
        layerManager.append(sprite);
    }

    public boolean die(){
        living = false;
        return true;
    }
}
