/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gamelibrary.game;
import gameactual.Coordinates;
import gamelibrary.gameobject.GameObject;

/**
 *
 * @author Griff
 */
public class Camera {
    private Coordinates viewCoords;
    private Coordinates maxScreenCoords;
    private int screenWidth;
    private int screenHeight;

    public Camera(int screenWidth, int screenHeight, Coordinates viewCoords, Coordinates maxScreenCoords){
        this.viewCoords = viewCoords;
        this.maxScreenCoords = maxScreenCoords;
        this.screenWidth = screenWidth;
        this.screenHeight = screenHeight;
    }

    public void trackGameObject(GameObject gameObject){
        int viewX = gameObject.getCoordinates().getX();
        int viewY = gameObject.getCoordinates().getY();
        viewX = viewX - screenWidth/2;
        viewY = viewY - screenHeight/2;
        if (viewX < 0){
            viewX = 0;
        }
        else if (viewX + screenWidth > maxScreenCoords.getX()){
            viewX = maxScreenCoords.getX() - screenWidth;
        }
        if (viewY < 0){
            viewY = 0;
        }
        else if (viewY + screenHeight > maxScreenCoords.getY()){
            viewY = maxScreenCoords.getY() - screenHeight;
        }
        viewCoords.setX(-viewX);
        viewCoords.setY(-viewY);
   }

}
